<?php
$ret = array(
    'name' => isset($_POST['name'])? $_POST['name'] : '',
    'gender' => isset($_POST['gender'])? $_POST['gender'] : ''
);

header('content-type:application:json;charset=utf8');

$origin = isset($_SERVER['HTTP_ORIGIN'])? $_SERVER['HTTP_ORIGIN'] : '';

$allow_origin = array(
    'https://www.edmac.com.cn','https://oversea-edmac.modeness.com'
);

if(in_array($origin, $allow_origin)){
    header('Access-Control-Allow-Origin:'.$origin);
    header('Access-Control-Allow-Methods:*');
    header('Access-Control-Allow-Headers:x-requested-with,content-type');
}

// echo json_encode($ret);

ini_set("display_errors", "on");

require_once __DIR__ . '/api_sdk/vendor/autoload.php';

use Aliyun\Core\Config;
use Aliyun\Core\Profile\DefaultProfile;
use Aliyun\Core\DefaultAcsClient;
use Aliyun\Api\Sms\Request\V20170525\SendSmsRequest;
use Aliyun\Api\Sms\Request\V20170525\SendBatchSmsRequest;
use Aliyun\Api\Sms\Request\V20170525\QuerySendDetailsRequest;

// 加载区域结点配置
Config::load();

/**
 * Class SmsDemo
 *
 * 这是短信服务API产品的DEMO程序，直接执行此文件即可体验短信服务产品API功能
 * (只需要将AK替换成开通了云通信-短信服务产品功能的AK即可)
 * 备注:Demo工程编码采用UTF-8
 */
class SmsDemo
{

    static $acsClient = null;

    /**
     * 取得AcsClient
     *
     * @return DefaultAcsClient
     */
    public static function getAcsClient() {
        //产品名称:云通信短信服务API产品,开发者无需替换
        $product = "Dysmsapi";

        //产品域名,开发者无需替换
        $domain = "dysmsapi.aliyuncs.com";

        // TODO 此处需要替换成开发者自己的AK (https://ak-console.aliyun.com/)
        $accessKeyId = "LTAI5t5cZ7Rzh6mVNaB6qiwn"; // AccessKeyId

        $accessKeySecret = "N35jrBlbZ6BD6HYyvwwPLDAcuZlseL"; // AccessKeySecret

        // 暂时不支持多Region
        $region = "cn-hangzhou";

        // 服务结点
        $endPointName = "cn-hangzhou";


        if(static::$acsClient == null) {

            //初始化acsClient,暂不支持region化
            $profile = DefaultProfile::getProfile($region, $accessKeyId, $accessKeySecret);

            // 增加服务结点
            DefaultProfile::addEndpoint($endPointName, $region, $product, $domain);

            // 初始化AcsClient用于发起请求
            static::$acsClient = new DefaultAcsClient($profile);
        }
        return static::$acsClient;
    }

    /**
     * 发送短信
     * @return stdClass
     */
    public static function sendSms($con) {
        session_start();

        $data = $con['code'];
        if(session::get('phone'.$con['phone'])){// 未过期，不可发送短信
            $acsResponse = ['RequestId'=>$con['code'],'Message'=>'10秒内只能发送一次短信','Code'=>'false'];
        }else{// 已过期,可发送短信
            session::set('phone'.$con['phone'], $data, 10);

            $request = new SendSmsRequest();// 初始化

            //$request->setProtocol("https");//可选-启用https协议

            $request->setPhoneNumbers($con['phone']);// 必填，接收号码

            $request->setSignName("艾德玛");// 必填，设置签名

            $request->setTemplateCode("SMS_213420106");// 必填，设置模板CODE

            $request->setTemplateParam(json_encode(array(  // 短信模板中字段的值
                "code"=>$con['code']
            ), JSON_UNESCAPED_UNICODE));

            // 发起访问请求
            $acsResponse = static::getAcsClient()->getAcsResponse($request);
            //$acsResponse = ['RequestId'=>$con['code'],'Message'=>'可以发送短信了','Code'=>'yes'];
        }

        return json_encode($acsResponse);
    }
}

/**
* Session控制类
*/
class Session{

    /**
    * 设置session
    * @param String $name session name
    * @param Mixed $data session data
    * @param Int $expire 超时时间(秒)
    */
    public static function set($name, $data, $expire=60){
        $session_data = array();
        $session_data['data'] = $data;
        $session_data['expire'] = time()+$expire;
        $_SESSION[$name] = $session_data;
    }

    /**
    * 读取session
    * @param String $name session name
    * @return Mixed
    */
    public static function get($name){
        if(isset($_SESSION[$name])){
            if($_SESSION[$name]['expire']>time()){
                return $_SESSION[$name]['data'];
            }else{
                self::clear($name);
            }
        }
        return false;
    }

    /**
    * 清除session
    * @param String $name session name
    */
    private static function clear($name){
        unset($_SESSION[$name]);
    }

}

// 调用示例：
set_time_limit(0);
header('Content-Type: text/plain; charset=utf-8');
// $con=['phone'=>'','code'=>'123125'];
// $response = SmsDemo::sendSms($con);
// echo "发送短信(sendSms)接口返回的结果:\n";
// print_r($response);

//require APPPATH.'/smsDemo.php';
//$rand = rand(100000,999999);
//$_SESSION['rand'] = $rand;
//echo $_SESSION['rand'];die;
$con=[
    'phone'=>$_REQUEST['phone'],'code'=>$_REQUEST['code']
];
$response = SmsDemo::sendSms($con);
print_r($response);